"use strict";

exports.__esModule = true;
exports.default = maybePromisify;

function maybePromisify(hook, syncLength) {
  if (hook.length <= syncLength) {
    return hook;
  }

  return function () {
    var hasSyncResult = false;
    var syncResult;
    var resolvePromise;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    hook.apply(void 0, args.concat([function (result) {
      if (resolvePromise) {
        resolvePromise(result);
        return;
      }

      hasSyncResult = true;
      syncResult = result;
    }]));

    if (!hasSyncResult) {
      return new Promise(function (resolve) {
        resolvePromise = resolve;
      });
    }

    return syncResult;
  };
}

module.exports = exports.default;